

/** 
 Classe per a implementar els objectes que fan d'etiquetes.
 Utilitza la classe TextLabel de la llibreria ControlP5.
 */

import java.util.*;
public final class   ControladorLabel {
  public Textlabel l=null;
  /**
   Controlador per a les etiquetes superior esquerra.
   */
  public ControladorLabel(int x, int y, int w, int h, int id, String nom, final int colorEtiqueta) {
    l = controlP5.addTextlabel(nom)
      .setPosition(x, y)
      .setSize(w, h)
      .setColor(0xff000000)
      .setMultiline(true)
      .setFont(createFont("Verdana", 11))
      .setId(id);
    l.get().setColorBackground(colorEtiqueta);
    l.get().setLineHeight(15);
    l.onEnter(new CallbackListener() {
      public void controlEvent(CallbackEvent e) {
        // CAS D'US: L'usuari situa el punter al damunt de l'etiqueta.
        //REQUISIT_1: pintar l'etiqueta d'un color més clar.
        l.get().setColorBackground((int)(colorEtiqueta ^ 0x88000000));
      }
    }
    ).onLeave(new CallbackListener() {
      // CAS D'US: L'usuari ha situat el punter al damunt de l'etiqueta i el treu.
      //REQUISIT_1: pintar l'etiqueta del color original.
      public void controlEvent(CallbackEvent e) {
        l.get().setColorBackground(colorEtiqueta);
      }
    }
    ).onPress(new CallbackListener() {
      public void controlEvent(CallbackEvent e) {
        // CAS D'US: L'usuari ha clicat l'etiqueta.
        //REQUISIT_1: pintar el pla corresponent al representat per l'etiqueta.
        controlador3D.pintaPla(l.getName());
      }
    }
    );
  }
  /**
   Etiquetes per als noms fixos de totes les variables de la gravetat, el temps i el calibrat.
   */
  public ControladorLabel(int x, int y, int w, int h, int id, String nom, String valor) {
    l = controlP5.addTextlabel(nom)
      .setStringValue(valor)
      .setPosition(x, y)
      .setSize(w, h)
      .setColor(0xff000000)
      .setFont(createFont("Verdana", 11))
      .setId(id);
    l.get().setColorBackground(0xffffff00);//color groc
    if (!valor.equals(""))l.get().align(CENTER, CENTER);
  }

  /**
   Etiquetes per als valors de les variables de la gravetat
   */
  public ControladorLabel(int x, int y, int w, int h, int id, String nom) {
    l = controlP5.addTextlabel(nom)
      .setPosition(x, y)
      .setSize(w, h)
      .setColor(0xff0000ff)
      .setFont(createFont("Verdana", 11))
      .setId(id);
    l.get().align(CENTER, CENTER);
  }


  /**
   Controlador per a la botonera dels objectes que es visualitzen a l'escena 3D i per
   a triar el gràfic que volem visualitzar (Euler o gravetat).
   */
  public ControladorLabel(int x, int y, int w, int h, String nom, final int id, final int colorEtiqueta) {
    l = controlP5.addTextlabel(nom)
      .setStringValue(nom)
      .setPosition(x, y)
      .setSize(w, h)
      .setMultiline(true)
      .setColor(0xff000000)//color de la lletra
      .setFont(createFont("Verdana", 11))
      .setId(id);
    l.get().setColorBackground(colorEtiqueta);//color de l'etiqueta
    l.onEnter(new CallbackListener() {
      public void controlEvent(CallbackEvent e) {
        // CAS D'US: L'usuari situa el punter al damunt de l'etiqueta.
        //REQUISIT_1: pintar l'etiqueta d'un color més clar.
        l.get().setColorBackground((int)(colorEtiqueta ^ 0x88000000));
      }
    }
    ).onLeave(new CallbackListener() {
      public void controlEvent(CallbackEvent e) {
        // CAS D'US: L'usuari ha situat el punter al damunt de l'etiqueta i el treu.
        //REQUISIT_1: pintar l'etiqueta del color original.
        l.get().setColorBackground(colorEtiqueta);
      }
    }
    ).onPress(new CallbackListener() {
      public void controlEvent(CallbackEvent e) {
        // CAS D'US: L'usuari ha clicat l'etiqueta.
        //REQUISIT_1: modificcar el flag que controlem amb aquesta etiqueta.
        controladorPanel.canviaEstat(l);
      }
    }
    );
  }
}
