 //<>//

/** 
 Classe per a dibuixar la zona 5 de la interficie, botonera, panel de dades i llista desplegable.
 */
public final class ControladorPanel {
  private ModelPrincipal mp = null;
  private ModelDades model = null;
  private VistaDades vista = null;
  private BD1 BD = null;

  /**
   Mètode constructor, sol·licitat pel controladorPrincipal.
   */
  public ControladorPanel(ModelPrincipal modelPrincipal) { 
    //Objectes per a implementar l'arquitectura MODEL_VISTA_CONTROLADOR
    mp = modelPrincipal;
    this.BD = new BD1();
    model = new ModelDades();
    vista = new VistaDades();
  } 

  public  void setValorLabel(int id, float v) {
    vista.lv[id].l.setStringValue(getValor(v, 10000));
  }
  public  void setValorAngle(int id, float v) {
    vista.lv[id].l.setStringValue( getValor(v, 100)+BD.s_grau);
  }

  private  String getValor(float v, float precisio) {
    return str(int(round(v*precisio))/precisio);
  }
  public void resetlabelsGravetat() {
    setValorLabel(BD.M_X, mp.modul);
    setValorLabel(BD.CV_X, mp.cp);
    setValorLabel(BD.CH_X, mp.cy);
    setValorLabel(BD.OX, mp.ox/10.0);
    //
    setValorLabel(BD.M_Y, mp.modul);
    setValorLabel(BD.CV_Y, mp.cp);
    setValorLabel(BD.SH_Y, mp.sy);
    setValorLabel(BD.OY, mp.oy/10.0);
    //
    setValorLabel(BD.M_Z, mp.modul);
    setValorLabel(BD.SV_Z, mp.sp);
    setValorLabel(BD.OZ, mp.oz/10.0);
    // 
    setValorLabel(BD.M_P, mp.modul);  
    setValorLabel(BD.OP, mp.op); 
    setValorLabel(BD.CV_P, mp.cp);
    //
    setValorAngle(BD.alfa, degrees(mp.ai));
    setValorAngle(BD.beta, degrees(mp.aj));
    setValorAngle(BD.gamma, degrees(mp.ak));
    //
    setValorAngle(BD.phi, mp.phi_g);
    setValorAngle(BD.theta, mp.theta_g);
  }

  public void resetValorsCalibrat() {
    setValorLabel(BD.id_giroscopi, mp.gyro);
    setValorLabel(BD.id_accelerometre, mp.accel);
    setValorLabel(BD.id_magnetometre, mp.mag);
    setValorLabel(BD.id_sistema, mp.sys);
  }

  /**
   Mètode per a canviar l'estat del flag relacionat amb l'etiqueta passada per paràmetre.
   */
  public void canviaEstat(Textlabel l) {
    if (l.getName().equals(BD.b_noms[BD.GRAFICA_GRAVETAT])) {
      model.pintaGraficaEuler= !model.pintaGraficaEuler;
      model.pintaGraficaGravetat= !model.pintaGraficaGravetat;
      controladorGrafica.setCanviGrafic();
      if (!model.pintaGraficaEuler) l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.GRAFICA_EULER]);
    } else if (l.getName().equals(BD.b_noms[BD.B_PLANOLS])) {
      model.pintarPlans = !model.pintarPlans;
      if (!model.pintarPlans)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_PLANOLS+1]);
    } else if (l.getName().equals(BD.b_noms[BD.B_PLANOS_COLOR])) {
      model.pintarPlansColor = !model.pintarPlansColor;
      if (!model.pintarPlansColor)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_PLANOS_COLOR+1]);
    } else if (l.getName().equals(BD.b_noms[BD.B_EIXOS])) {
      model.pintarEixos = !model.pintarEixos;
      if (!model.pintarEixos)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_EIXOS+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_GRAVETAT])) {
      model.pintaGravetat= !model.pintaGravetat;
      if (!model.pintaGravetat)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_GRAVETAT+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_IMU])) {
      model.pintaIMU= !model.pintaIMU;
      if (!model.pintaIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD .B_IMU+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_EIXOS_IMU])) {
      model.pintaEixosIMU= !model.pintaEixosIMU;
      if (!model.pintaEixosIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_EIXOS_IMU+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_ANGLES_IMU])) {
      model.pintaAnglesIMU= !model.pintaAnglesIMU;
      if (!model.pintaAnglesIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD .B_ANGLES_IMU+1]);
    }
  }
  
  /**
   Mètode per a canviar el valor que mostra  l'etiqueta passada per paràmetre.
   */
  public void setEstat(Textlabel l) {
    if (l.getName().equals(BD.b_noms[BD.GRAFICA_GRAVETAT])) {
      if (!model.pintaGraficaEuler)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.GRAFICA_EULER]);
    } else if (l.getName().equals(BD.b_noms[BD.B_PLANOLS])) {
      if (!model.pintarPlans)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_PLANOLS+1]);
    } else if (l.getName().equals(BD.b_noms[BD.B_PLANOS_COLOR])) {
      if (!model.pintarPlansColor)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_PLANOS_COLOR+1]);
    } else if (l.getName().equals(BD.b_noms[BD.B_EIXOS])) {
      if (!model.pintarEixos)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_EIXOS+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_GRAVETAT])) {
      if (!model.pintaGravetat)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD .B_GRAVETAT+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_IMU])) {
      if (!model.pintaIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD .B_IMU+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_EIXOS_IMU])) {
      if (!model.pintaEixosIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_EIXOS_IMU+1]);
    } else if (l.getName().equals(BD.b_noms[BD .B_ANGLES_IMU])) {
      if (!model.pintaAnglesIMU)l.setStringValue(l.getName());
      else l.setStringValue(BD.b_noms[BD.B_ANGLES_IMU+1]);
    }
  }

  public void pintaCaixes() {
    vista.pintacaixes();
  }

  public boolean isSeleccionat(int valor) {
    boolean estat = false;
    switch(valor) {
    case 0:
      estat =  model.pintaGraficaGravetat; 
      break;
    case 1:
      estat =  model.pintaGraficaEuler; 
      break;
    case 2: 
      estat =  model.pintarPlans; 
      break;
    case 3:
      estat =  model.pintarPlansColor; 
      break;
    case 4:
      estat =  model.pintarEixos; 
      break;
    case 5:
      estat =  model.pintaGravetat; 
      break;
    case 6:
      estat = model.pintaIMU; 
      break;
    case 7:
      estat = model.pintaEixosIMU; 
      break;
    case 8:
      estat = model.pintaAnglesIMU; 
      break;
    }
    return estat;
  }  
  //BASE DADES//////////////////////////////////////////////////// ///////////////////////////
  /**
   Classe per a encapsular les variables de valor fix.
   */
  private class BD1 {

    public BD1() {
    }

    // Constants per a indexar les etiquetes.
    public final int  OX = 0;
    public final int  M_X = 1;
    public final int  CV_X = 2;
    public final int  CH_X = 3;
    ///
    public final int  OY = 4;
    public final int  M_Y = 5;
    public final int  CV_Y = 6;
    public final int  SH_Y = 7;
    ///
    public final int  OZ = 8;
    public final int  M_Z = 9;
    public final int  SV_Z =10;
    ///
    public final int  OP = 11;
    public final int  M_P = 12;
    public final int  CV_P = 13;
    ///
    public final int  alfa = 14;
    public final int  beta = 15;
    public final int  gamma = 16;
    ///
    public final int  theta =17; 
    public final int  phi = 18;
    ///
    public final int  id_giroscopi = 19;
    public final int  id_accelerometre= 20;
    public final int  id_magnetometre = 21;
    public final int  id_sistema = 22;
    ///
    public  final String s_alfa = new String(Character.toChars(unhex("03B1")));
    public  final String s_beta = new String(Character.toChars(unhex("03B2")));
    public  final String s_gamma = new String(Character.toChars(unhex("03B3")));
    public  final String s_theta = new String(Character.toChars(unhex("03B8"))); 
    public  final String s_phi = new String(Character.toChars(unhex("03C6")));
    public final String  s_grau = "º";
    ///
    //Taula de constants per als valors fixos que mostren les etiquetes
    public final String[]valors ={ 
      "OX = ", "OA *", "cos_"+s_phi+" *", "cos_"+s_theta, 
      "OY = ", "OA *", "cos_"+s_phi+" *", "sin_"+s_theta, 
      "OZ = ", "OA *", "sin_"+s_phi, 
      "OP = ", "OA *", "cos_"+s_phi, 
      s_alfa+" = ", s_beta+" = ", s_gamma+" = ", 
      s_theta+" = ", s_phi+" = ", 
      "GIR", "ACC", "MAG", "SYS"};
    //Taula de constants per a indexar les etiquetes que mostren valors 
    public final String[]v_claus ={ 
      "OXv", "M_Xv", "CV_Xv", "CH_Xv", 
      "OYv", "M_Yv", "CV_Yv", "SH_Yv", 
      "OZv", "M_Zv", "SV_Zv", 
      "OPv", "M_Pv", "CV_Pv", 
      s_alfa+"v", s_beta+"v", s_gamma+"v", 
      s_theta+"v", s_phi+"v", 
      "GIRv", "ACCv", "MAGv", "SYSv"};
    //Taula de constants per a indexar el nom de les etiquetes que mostren valors 
    public  final String[]n_claus ={ 
      "OXc", "M_Xc", "CV_Xc", "CH_Xc", 
      "OYc", "M_Yc", "CV_Yc", "SH_Yc", 
      "OZc", "M_Zc", "SV_Zc", 
      "OPc", "M_Pc", "CV_Pc", 
      s_alfa+"c", s_beta+"c", s_gamma+"c", 
      s_theta+"c", s_phi+"c", 
      "GIRc", "ACCc", "MAGc", "SYSc"};
    //VARIABLES PER A GESTIONAR ELS BOTONS /////////////////////////  /////////////////////////  ///////////////////////// 
    //Taula per a desar el valor que mostra l'etiqueta que representa un boto en funció del seu estat.
    public final  String[] b_noms ={ 
      "Grafica GRAVETAT", "Grafica EULER", 
      "Pinta Planols", "Amaga Planols", 
      "Pinta PlanolsColor", "Amaga Planols Color", 
      "Pinta Eixos", "Amaga Eixos", 
      "Pinta Gravetat", "Amaga Gravetat", 
      "Pinta IMU", "Amaga IMU", 
      "Pinta EixosIMU", "Amaga EixosIMU", 
      "Pinta AnglesIMU", "Amaga AnglesIMU", 
      "Roll_RY FRONTAL", "GX   \nPLA_ZY", 
      "Pitch_RX SAGITAL", "GY \nPLA_ZX", 
      "Yaw_RZ HORITZONTAL", "GZ \nPLA_XY", 
      "hora" };
    //llista d'identificadors per als botons.
    public final int GRAFICA_GRAVETAT= 0;
    public final int GRAFICA_EULER= 1;
    public final int PLANS= 2;
    public final int  PLANS_COLOR=3;
    public final int  EIXOS= 4;
    public final int  GRAVETAT = 5;
    public final int  IMU = 6;
    public final int  EIXOS_IMU= 7;
    public final int  ANGLES_IMU = 8;
    // Constants per a indexar els botons.
    public final int B_TIPUS_GRAFICA=0;
    public final int B_PLANOLS=2;
    public final int B_PLANOS_COLOR=4;
    public final int B_EIXOS=6;
    public final int B_GRAVETAT=8;
    public final int B_IMU=10;
    public final int B_EIXOS_IMU=12;
    public final int B_ANGLES_IMU=14;

    public   String getValor(int id) {
      return b_noms[id];
    }
  }

  //MODEL//////////////////////////////////////////////////// ///////////////////////////
  private class ModelDades {
    //Variables per a controlar l'estat dels botons.
    public  boolean pintaGraficaEuler= true;
    public  boolean pintaGraficaGravetat= false;
    public  boolean pintarPlans= true;
    public  boolean pintarEixos= true;
    public  boolean pintarPlansColor= false;
    public  boolean pintaIMU = true;
    public  boolean pintaEixosIMU= true;
    public  boolean pintaAnglesIMU = true;
    public  boolean pintaGravetat = false;
  }
  //VISTA//////////////////////////////////////////////////// ///////////////////////////
  private class VistaDades {
    private  ControladorLabel[] ln, lv, lb;

    public VistaDades() {
      creaLabelsNomValor();
      creLabelsBoto();
    }

    /**
     mètode per a pintar els quadres que rodegen a la representació de les variables.
     */
    public void pintacaixes() {
      noFill();
      rect(BDPrincipal.AMPLE/2-50, BDPrincipal.ALSADA/2+60, 120, 200);
      rect(BDPrincipal.AMPLE/2+80, BDPrincipal.ALSADA/2+60, 225, 132);
      rect(BDPrincipal.AMPLE/2+80, BDPrincipal.ALSADA/2+60+132, 225, 68);
      rect(BDPrincipal.AMPLE/2+315, BDPrincipal.ALSADA/2+60, 210, 35);
    }

    /**
     mètode per a pintar la botonera.
     */
    private void creLabelsBoto() {
      //Etiquetes amb interactivitat.
      int px =Principal.BDPrincipal.AMPLE/2-48;
      int py =Principal.BDPrincipal.ALSADA/2+65;
      int w =115;
      int h = 15;
      int idCol =0;
      lb = new ControladorLabel[8];
      for (int i =0; i< lb.length; i++) {
        lb[i]= new ControladorLabel(px, py, w, h, BD.getValor(idCol), idCol, 0xffff851B);
        setEstat(lb[i].l);
        py +=25;
        idCol +=2;
      }
    }

    /**
     Mètode per a pintar la representació dels paràmetres de la gravetat i calibrat.
     */
    private  void  creaLabelsNomValor() {
      ln = new ControladorLabel[24];
      lv = new ControladorLabel[24];
      int px =Principal.BDPrincipal.AMPLE/2+10;
      int py =Principal.BDPrincipal.ALSADA/2+60;
      int idCol=0;
      //Etiquetes per a mostrar els paràmetres de la Gravetat.
      for (int id =0; id< 4; id++) {
        //Etiquetes per al nom de la variable.
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        //Etiquetes per als valors de la variable.
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      py +=33;
      px =Principal.BDPrincipal.AMPLE/2+10;
      idCol =4;
      for (int id =0; id< 4; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      py +=33;
      px =Principal.BDPrincipal.AMPLE/2+10;
      idCol =8;
      for (int id =0; id< 3; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      py +=33;
      px =Principal.BDPrincipal.AMPLE/2+10;
      idCol =11;
      for (int id =0; id< 3; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      py +=33;
      px =Principal.BDPrincipal.AMPLE/2+10;
      idCol =14;
      for (int id =0; id< 3; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      ///////////////////////////////////
      py +=33;
      px =Principal.BDPrincipal.AMPLE/2+10;
      idCol=17;
      for (int id =0; id< 2; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
      ///////////////////////////////////// 
      px =Principal.BDPrincipal.AMPLE/2+10 +225;
      py =Principal.BDPrincipal.ALSADA/2+60;
      idCol =19;
      for (int id =0; id< 4; id++) {
        ln[idCol]= new ControladorLabel(px, py, 60, 15, id*10, BD.n_claus[idCol], BD.valors[idCol] );
        lv[idCol]= new ControladorLabel(px, py+15, 60, 15, id, BD.v_claus[idCol]);
        px +=55;
        idCol++;
      }
    }
  }
}
