
/**
 Classe per a implementar el objectes que fan de roda.
 hereda de la classe Numberox i sobreescriu els mètodes que interesen.
 */
public class  ControladorRoda extends Numberbox {
  /**
   Constructor.
   */
  public ControladorRoda(int x, int y, int w, int h, int id, String nom) {
    super(controlP5, nom);
    getCaptionLabel().setVisible(false);
    setScrollSensitivity(1)
      .setColorBackground(ControlP5.ORANGE)
      .setColorForeground(ControlP5.ORANGE)
      .setColorValueLabel(ControlP5.BLACK)
      .setDecimalPrecision(0)
      .setPosition(x, y)
      .setFont(createFont("Verdana", 11))
      .setSize(w, h)
      .setId(id);
  }

  /**
   Mètode per a establir el rang del valor que ha de regular
   i escriure l'unitat de messura al costat de valor.
   */
  public void setRang(int v1, int v2, String unitatMesura) {
    setRange(v1, v2);
    if (abs(v1)>abs(v2)) {
      //Carreguem el valor
      setValue(v1);
      //Modifiquem el valor que mostra la interficie.
      getValueLabel().setText(v1+unitatMesura);
    } else {
      setValue(v2);
      getValueLabel().setText(v2+unitatMesura);
    }
  }

  /**
   Mètode per a esciure el valor i l'unitat de messura.
   */
  public void setValor(int v1, String unitatMesura) {
    getValueLabel().setText(v1+unitatMesura);
  }
  /**
   Mètode sobbreescrit, fa el mateix que l'original, pero s'ha eliminat
   la funcionalitat de modificar el valor que mostra l'objecte.
   */
  @Override
    public Numberbox setValue( float theValue ) {
    _myValue = theValue;
    _myValue = Math.max( _myMin, Math.min( _myMax, _myValue ) );
    broadcast( FLOAT );
    //  _myValueLabel.set( adjustValue( _myValue ) );
    return this;
  }

  @Override
    public void onEnter() {
    // CAS D'US: L'usuari situa el punter al damunt de l'etiqueta.
    //REQUISIT_1: pintar l'etiqueta d'un color blanc.
    //REQUISIT_2: mostrar el punter amb el dibuix d'una ma que assenyala.
    setColorBackground(ControlP5.WHITE);
    cursor(HAND);
  }
  @Override
    void onReleaseOutside() {
    onLeave();
  }
  @Override
    void onLeave() {
    // CAS D'US: L'usuari retira el punter de damunt de l'etiqueta.
    //REQUISIT_1: pintar l'etiqueta d'un color taronja.
    //REQUISIT_2: mostrar el punter amb el dibuix d'una fletxa.
    setColorBackground(ControlP5.ORANGE);
    cursor(ARROW);
  }
  @Override
    public Numberbox scrolled( int theRotationValue ) {
    // CAS D'US: L'usuari possa el punter al damunt d'una etiqueta i fa rodar el boto central del ratolí.
    //REQUISIT_1: modificar el valor que representa l'etiqueta i pintar la nova situació.
    if (getId()==controladorCamera.BD.id_r_theta)
      controladorCamera.rodaAngleTheta(theRotationValue);
    else if (getId()==controladorCamera.BD.id_r_phi)
      controladorCamera.rodaAnglePhi(theRotationValue);
    else if (getId()==controladorGrafica.BD.idr_fps)
      controladorGrafica.modificaFps(theRotationValue);
    else 
    controladorGrafica.mouLimits(theRotationValue, getId());
    return this;
  }
}
